#include "medium_link.h"


Medium_Link::Medium_Link()
{
  cout<<"Cannot use default constructor for Medium_link!"<<endl;
  exit(-1);
}

Medium_Link::Medium_Link(long p_pop, double p_chan, double p_arr, 
			 long p_avpcktln):
  station_population(p_pop),
  radio(0),
  collision(0),
  channel_speed(p_chan),
  succes(0.0),
  a_load(0.0)
{
  for(long i=0;i<station_population;i++)
      stations.push_back(new struct Aloha(i,this,p_arr,p_avpcktln));
}

Medium_Link::~Medium_Link() 
{
  for(long i=0;i<station_population;i++)
    delete(stations[i]);
  stations.clear();
}


void Medium_Link::Transmission_Starts(long p_bytes,long src_id)
{
  if(radio==0)
    {
      radio=1;
      collision=false;
    }
  else
    {
      radio++;
      collision=true;
    }
  new DSEvent(this,8.0*p_bytes/channel_speed,S_Transmission_Over,p_bytes,src_id);  
  a_load+=p_bytes;
}

void Medium_Link::S_Transmission_Over(void * p_p, long p_bytes, long p_src)
{
  ((Medium_Link*)p_p)->Transmission_Over(p_bytes,p_src);
}

void Medium_Link::Transmission_Over(long p_bytes, long p_src)
{
  if(radio<=0)
    {
      cout<<"Error in Medium_Link: Transmission_Over"<<endl;
      exit(-1);
    }
  if((radio==1)&&(!collision))
    {
      for(long i=0;i<station_population;i++)
	if(p_src!=i)
	  stations[i]->Incoming_packet(p_src,p_bytes);
      succes+=p_bytes;
    }
  radio--;
  if(radio==0)
    collision=false;
  stations[p_src]->Packet_transmission_over();
}

